package stopAwait;

import java.net.*;
import java.io.*;

public class Client {
	private final String STR_ACK = "ACK";
	
	//streams to communicate with server
	private ObjectOutputStream oos;
	private ObjectInputStream ois;
	
	public static void main(String[] args) {
		Client client = new Client();
		client.run();
	}
	
	public void run() {
		Socket socket = new Socket();
		int iOption;
	
		try {
			//connect to server
			socket.connect((new InetSocketAddress("127.0.0.1", 2007)));
			//get output and input stream
			oos = new ObjectOutputStream(socket.getOutputStream());
			ois = new ObjectInputStream(socket.getInputStream());
			
			//begin main loop
			iOption = getUserInput();
			while (iOption != 4) {
				//sent the question to server
				SendMessage (iOption);
				//receive message 
				System.out.println("Server: " + RecvMessage ());
								
				//read next input
				iOption = getUserInput();
			}
			
			//inform server to quit
			SendMessage (iOption);
			
			//close up
			oos.close();
			ois.close();
			socket.close();
		}
		catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}	
	
	private int getUserInput() throws IOException{
		int rtn = -1;
		BufferedReader stdin = new BufferedReader (new InputStreamReader(System.in));
				
		System.out.println();
		System.out.println("1: Question 1.");
		System.out.println("2: Question 2.");
		System.out.println("3: Question 3.");
		System.out.println("4: Quit 4.");
		System.out.println("Please input your selection:");
		rtn = Integer.parseInt(stdin.readLine());
		
		switch (rtn) {
		case 1: 
			System.out.println("Client: Question 1.");
			break;
		case 2: 
			System.out.println("Client: Question 2.");
			break;
		case 3: 
			System.out.println("Client: Question 3.");
			break;
		}
		
		return rtn;
	}
	
	private void SendMessage(int msg) throws IOException{
		//send message
		oos.writeInt(msg);
		//send out immediately
		oos.flush();
		//wait for acknowledgement
		try {
			//no check here for simplicity
			ois.readObject();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
	
	private String RecvMessage () throws IOException{
		String rtn = "";
		
		try {
			//receive message
			rtn = (String) ois.readObject();
			//send acknowledgement
			oos.writeObject(STR_ACK);
			//send out immediately
			oos.flush();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
			System.exit(1);			
		}
		return rtn;
	}
}
