package stopAwait;

import java.net.*;
import java.io.*;

public class Server {
	private final String STR_ACK = "ACK";
	
	//streams to communicate with server
	private ObjectOutputStream oos;
	private ObjectInputStream ois;

	public static void main(String[] args) {
		Server server = new Server();
		server.run();		
	}
	
	public void run() {
		ServerSocket ssocket;
		Socket socket;
		int iOption;
		String strAnswer="";
	
		try {
			//create socket
			ssocket = new ServerSocket();
			//bind to a port
			ssocket.bind(new InetSocketAddress(2007));
			//accept connection from client
			socket = ssocket.accept();
			//get output and input stream
			oos = new ObjectOutputStream(socket.getOutputStream());
			ois = new ObjectInputStream(socket.getInputStream());
			
			//begin main loop
			iOption = RecvMessage();
			while (iOption != 4) {
				//choose the right answer
				switch (iOption) {
				case 1:
					strAnswer = "Answer 1.";
					break;
				case 2:
					strAnswer = "Answer 2.";
					break;
				case 3:
					strAnswer = "Answer 3.";
					break;
				}
				
				//sent the answer to client
				SendMessage (strAnswer);
								
				//read next input
				iOption = RecvMessage();
			}
			
			//close up
			oos.close();
			ois.close();
			socket.close();
			ssocket.close();
		}
		catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
	
	private void SendMessage(String msg) throws IOException{
		//send message
		oos.writeObject(msg);
		//send out immediately
		oos.flush();
		//wait for acknowledgement
		try {
			//no check here for simplicity
			ois.readObject();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
	
	private int RecvMessage () throws IOException{
		int rtn;
		
		//receive message
		rtn = ois.readInt();
		//send acknowledgement
		oos.writeObject(STR_ACK);
		//send out immediately
		oos.flush();
		
		return rtn;
	}
}
